blob: 27c7811a33c17f83159a22df7b7bdbe3ad657074 [file] [log] [blame]
Igor Murashkineaddcd42012-11-26 12:01:11 -08001#!/bin/bash
2
3#
4# Copyright (C) 2012 The Android Open Source Project
5#
6# Licensed under the Apache License, Version 2.0 (the "License");
7# you may not use this file except in compliance with the License.
8# You may obtain a copy of the License at
9#
10# http://www.apache.org/licenses/LICENSE-2.0
11#
12# Unless required by applicable law or agreed to in writing, software
13# distributed under the License is distributed on an "AS IS" BASIS,
14# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15# See the License for the specific language governing permissions and
16# limitations under the License.
17#
18
19#
20# Generate all files we have templates for:
21# docs.html
22# ../src/camera_metadata_tag_info.c
23# ../src/camera_metadata_tags.h
Colin Crossabc7c492017-05-05 09:36:03 -070024# ../../../../frameworks/av/camera/ndk/include/camera/NdkCameraMetadataTags.h
Yin-Chia Yehea7662f2015-12-22 16:25:00 -080025# ../../../../frameworks/av/camera/ndk/impl/ACameraMetadata.cpp
Yin-Chia Yeh6c58d0a2015-12-05 17:20:33 -080026# ../../../../cts/tests/camera/src/android/hardware/camera2/cts/CaptureResultTest.java
Igor Murashkin21d0f1a2013-09-10 12:25:56 -070027# ../../../../frameworks/base/core/java/android/hardware/camera2/CameraCharacteristics.java
28# ../../../../frameworks/base/core/java/android/hardware/camera2/CaptureRequest.java
29# ../../../../frameworks/base/core/java/android/hardware/camera2/CaptureResult.java
Igor Murashkineaddcd42012-11-26 12:01:11 -080030
Igor Murashkinaa133d32013-06-28 17:27:49 -070031if [[ -z $ANDROID_BUILD_TOP ]]; then
32 echo "Please source build/envsetup.sh before running script" >& 2
33 exit 1
34fi
35
Eino-Ville Talvala08885562013-03-18 09:43:57 -070036thisdir=$(cd "$(dirname "$0")"; pwd)
Eino-Ville Talvala47aa24d2013-07-25 17:10:11 -070037fwkdir="$ANDROID_BUILD_TOP/frameworks/base/core/java/android/hardware/camera2/"
Eino-Ville Talvala0d404952017-11-10 15:13:04 -080038fwkdir_html="$ANDROID_BUILD_TOP/frameworks/base/docs/html/reference"
Yin-Chia Yeh6c58d0a2015-12-05 17:20:33 -080039ctsdir="$ANDROID_BUILD_TOP/cts/tests/camera/src/android/hardware/camera2/cts"
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -070040outdir="$ANDROID_PRODUCT_OUT/obj/ETC/system-media-camera-docs_intermediates"
Colin Crossabc7c492017-05-05 09:36:03 -070041ndk_header_dir="$ANDROID_BUILD_TOP/frameworks/av/camera/ndk/include/camera"
Yin-Chia Yehea7662f2015-12-22 16:25:00 -080042ndk_impl_dir="$ANDROID_BUILD_TOP/frameworks/av/camera/ndk/impl"
Yin-Chia Yehcf145ce2016-04-01 17:37:47 -070043device_info_dir="$ANDROID_BUILD_TOP/cts/tools/cts-device-info/"`
44 `"src/com/android/cts/deviceinfo"
Igor Murashkin1232dd22013-06-21 12:10:42 -070045out_files=()
Igor Murashkineaddcd42012-11-26 12:01:11 -080046
Igor Murashkin5804a482012-12-05 13:06:59 -080047function relpath() {
48 python -c "import os.path; print os.path.relpath('$1', '$PWD')"
49}
50
Igor Murashkin1232dd22013-06-21 12:10:42 -070051# Generates a file. Appends to $out_files array as a side effect.
Igor Murashkineaddcd42012-11-26 12:01:11 -080052function gen_file() {
53 local in=$thisdir/$1
54 local out=$thisdir/$2
55
Igor Murashkinaa133d32013-06-28 17:27:49 -070056 gen_file_abs "$in" "$out"
57 return $?
58}
59
60function gen_file_abs() {
61 local in="$1"
62 local out="$2"
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -070063 local intermediates="$3"
Eino-Ville Talvala0d404952017-11-10 15:13:04 -080064 local spec_file=$thisdir/metadata_definitions.xml
Yin-Chia Yehc9c2c682016-05-25 01:29:55 -070065
66 python $thisdir/metadata_parser_xml.py $spec_file $in $out
Igor Murashkin5804a482012-12-05 13:06:59 -080067
68 local succ=$?
69
70 if [[ $succ -eq 0 ]]
71 then
72 echo "OK: Generated $(relpath "$out")"
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -070073 if [[ "$intermediates" != "no" ]]; then
74 out_files+=$'\n'" $out"
75 fi
Igor Murashkin5804a482012-12-05 13:06:59 -080076 else
77 echo "FAIL: Errors while generating $(relpath "$out")" >& 2
78 fi
79
80 return $succ
Igor Murashkineaddcd42012-11-26 12:01:11 -080081}
82
Igor Murashkin1232dd22013-06-21 12:10:42 -070083# Print a list of git repository paths which were affected after file generation
84function affected_git_directories() {
85 local input_files=($@)
86 local git_directories=()
87
88 for file in "${input_files[@]}"; do
89 local dir_path="$(dirname "$file")"
90 echo "Trying to cd into $dir_path" >& /dev/null
91 # Absolute path to the git repository root of that file
92 local git_path="$(cd "$dir_path";
93 git rev-parse --show-toplevel 2> /dev/null)"
94 if [[ $? -eq 0 ]]; then
95 # Both staged and unstaged changes
Igor Murashkinb8dc8812013-07-17 16:29:34 -070096 local diff_result="$(cd "$dir_path";
97 git status --porcelain | egrep -c -v '^[?][?]')"
Igor Murashkin1232dd22013-06-21 12:10:42 -070098 echo "Diff result was $diff_result" >& /dev/null
99 echo "Diff result was $diff_result" >& /dev/null
100 if [[ $diff_result -eq 0 ]]; then
Igor Murashkinaa133d32013-06-28 17:27:49 -0700101 echo "No changes in ${git_path}" >& /dev/null
Igor Murashkin1232dd22013-06-21 12:10:42 -0700102 else
103 echo "There are changes in ${git_path}" >& /dev/null
104 git_directories+=("$git_path")
105 fi
106 fi
107 done
108
109 # print as result the unique list of git directories affected
Igor Murashkinaa133d32013-06-28 17:27:49 -0700110 printf %s\\n "${git_directories[@]}" | sort | uniq
Igor Murashkin1232dd22013-06-21 12:10:42 -0700111}
112
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700113# Insert a file into the middle of another, starting at the line containing the
114# start delim and ending on the end delim, both of which are replaced
115function insert_file() {
116 local src_part="$1"
117 local dst_file="$2"
118 local start_delim="/*@O~"
119 local end_delim="~O@*/"
120
121 local start_line="$(grep -n -F "${start_delim}" "${dst_file}" | cut -d: -f1)"
122 local end_line="$(grep -n -F "${end_delim}" "${dst_file}" | cut -d: -f1)"
123
124 # Adjust cutoff points to use start/end line from inserted file
125 (( start_line-- ))
126 (( end_line++ ))
127
128 # Do some basic sanity checks
129
130 if [[ -z "$start_line" ]]; then
131 echo "No starting delimiter found in ${dst_file}" >& 2
132 echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
133 return 1
134 fi
135
136 if [[ -z "$end_line" ]]; then
137 echo "No ending delimiter found in ${dst_file}" >& 2
138 echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
139 return 1
140 fi
141
142 if [[ "$start_line" -ge "$end_line" ]]; then
143 echo "Starting delim later than ending delim: $start_line vs $end_line" >& 2
144 echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
145 return 1
146 fi
147
148 local tmp_name=$(mktemp -t XXXXXXXX)
149
150 # Compose the three parts of the final file together
151
152 head -n "$start_line" "${dst_file}" > "${tmp_name}"
153 cat "${src_part}" >> "${tmp_name}"
154 tail -n "+${end_line}" "${dst_file}" >> "${tmp_name}"
155
156 # And replace the destination file with the new version
157
158 mv "${tmp_name}" "${dst_file}"
159 echo "OK: Inserted $(relpath "$src_part") into $(relpath "$dst_file")"
160 out_files+=$'\n'" $dst_file"
161}
162
Igor Murashkin1dd4ecb2013-12-11 13:31:00 -0800163# Recursively copy a directory tree from $1 to $2. Pretty-prints status.
164function copy_directory() {
165 local src="$thisdir/$1" # Relative to directory of this script
166 local dst="$2" # Absolute path
167
168 if ! [[ -d $src ]]; then
169 echo "FAIL: Source directory $src does not exist" >& 2
170 return 1
171 fi
172 if ! [[ -d $dst ]]; then
173 echo "FAIL: Destination directory $dst does not exist" >& 2
174 return 1
175 fi
176
177 cp -R "$src" "$dst"
178 local retval=$?
179
180 if [[ $retval -ne 0 ]]; then
181 echo "ERROR: Failed to copy $(relpath "$src") to $(relpath "$dst")" >& 2
182 else
183 echo "OK: Copied $(relpath "$src") to $(relpath "$dst")"
184 fi
185
186 return $retval
187}
188
Igor Murashkin0334aa02012-12-04 14:59:53 -0800189$thisdir/metadata-check-dependencies || exit 1
Eino-Ville Talvala0d404952017-11-10 15:13:04 -0800190$thisdir/metadata-validate $thisdir/metadata_definitions.xml || exit 1
Igor Murashkineaddcd42012-11-26 12:01:11 -0800191$thisdir/metadata-parser-sanity-check || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700192
193# Generate HTML properties documentation
Igor Murashkineaddcd42012-11-26 12:01:11 -0800194gen_file html.mako docs.html || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700195
196# Generate C API headers and implementation
Igor Murashkineaddcd42012-11-26 12:01:11 -0800197gen_file camera_metadata_tag_info.mako ../src/camera_metadata_tag_info.c || exit 1
198gen_file camera_metadata_tags.mako ../include/system/camera_metadata_tags.h || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700199
Yin-Chia Yehea7662f2015-12-22 16:25:00 -0800200#Generate NDK header
Eino-Ville Talvala0d404952017-11-10 15:13:04 -0800201gen_file_abs ndk_camera_metadata_tags.mako "$ndk_header_dir/NdkCameraMetadataTags.h" yes || exit 1
Yin-Chia Yehea7662f2015-12-22 16:25:00 -0800202
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700203# Generate Java API definitions
204mkdir -p "${outdir}"
205gen_file_abs CameraMetadataEnums.mako "$outdir/CameraMetadataEnums.java.part" no || exit 1
Igor Murashkin21d0f1a2013-09-10 12:25:56 -0700206gen_file_abs CameraCharacteristicsKeys.mako "$outdir/CameraCharacteristicsKeys.java.part" no || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700207gen_file_abs CaptureRequestKeys.mako "$outdir/CaptureRequestKeys.java.part" no || exit 1
208gen_file_abs CaptureResultKeys.mako "$outdir/CaptureResultKeys.java.part" no || exit 1
209
210insert_file "$outdir/CameraMetadataEnums.java.part" "$fwkdir/CameraMetadata.java" || exit 1
Igor Murashkin21d0f1a2013-09-10 12:25:56 -0700211insert_file "$outdir/CameraCharacteristicsKeys.java.part" "$fwkdir/CameraCharacteristics.java" || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700212insert_file "$outdir/CaptureRequestKeys.java.part" "$fwkdir/CaptureRequest.java" || exit 1
213insert_file "$outdir/CaptureResultKeys.java.part" "$fwkdir/CaptureResult.java" || exit 1
Yin-Chia Yehc9b27dd2016-02-23 19:18:15 -0800214
215# Generate CTS test code
216gen_file_abs CaptureResultTest.mako "$outdir/CaptureResultTest.java.part" no || exit 1
Yin-Chia Yeh3a52b8f2015-05-05 23:49:07 -0700217insert_file "$outdir/CaptureResultTest.java.part" "$ctsdir/CaptureResultTest.java" || exit 1
Eino-Ville Talvalad4e240a2013-08-08 12:56:37 -0700218
Yin-Chia Yehea7662f2015-12-22 16:25:00 -0800219# Generate NDK implementation
220gen_file_abs ACameraMetadata.mako "$outdir/ACameraMetadata.cpp.part" no || exit 1
221insert_file "$outdir/ACameraMetadata.cpp.part" "$ndk_impl_dir/ACameraMetadata.cpp" || exit 1
222
Yin-Chia Yehc9b27dd2016-02-23 19:18:15 -0800223# Generate CameraDeviceInfo code
224gen_file_abs CameraDeviceInfo.mako "$outdir/CameraDeviceInfo.java.part" no || exit 1
225insert_file "$outdir/CameraDeviceInfo.java.part" "$device_info_dir/CameraDeviceInfo.java" || exit 1
226
227# Generate protocol buffer definition corresponding to CameraDeviceInfo
228gen_file camera_device_info.mako ./camera_device_info.proto || exit 1
229
Igor Murashkin1dd4ecb2013-12-11 13:31:00 -0800230# Copy ./images directory into javadoc directory
231copy_directory "images" "$fwkdir_html" || exit 1
232
Igor Murashkin1232dd22013-06-21 12:10:42 -0700233echo ""
234echo "===================================================="
Igor Murashkineaddcd42012-11-26 12:01:11 -0800235echo "Successfully generated all metadata source files"
Igor Murashkin1232dd22013-06-21 12:10:42 -0700236echo "===================================================="
237echo ""
238
239echo "****************************************************"
240echo "The following git repositories need to be committed:"
241echo "****************************************************"
242echo ""
243affected_git_directories "${out_files[@]}"
244echo ""
Igor Murashkineaddcd42012-11-26 12:01:11 -0800245
246exit 0